#include<semaphore.h>
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>
#include <stdint.h>
#include <limits.h>
#include<fcntl.h> 
#include<unistd.h>
#include<string.h>
#include<sys/stat.h>
#include <sys/types.h>

int *fds;
int setSize=2;
int *readCounters;
sem_t *mutex;
sem_t *readerLocks;
sem_t x,y;
pthread_t tid;
pthread_t writerthreads[100],readerthreads[100];
int readercount = 0;

unsigned modulus( unsigned char *num, size_t size, unsigned divisor) {
  unsigned rem = 0;
  
  while (size-- > 0) {
    rem = ((UCHAR_MAX + 1ULL)*rem + *num) % divisor;
    num++;
  }
  return rem;
}
void file_del( char *key)
{   
    int index=modulus(key,256,setSize);
    fflush(stdout);
    int length=0;
    sem_wait(&mutex[index]);
    char blankspace[512];
     char ch;
    int k=-1;
    lseek(fds[index], 0, SEEK_SET);
    memset(blankspace,0,512);
     char *line;
     char temp[514];
    size_t len=0;
    off_t position=0;
    FILE *fp=fdopen(fds[index],"rb+");
    while ((getline(&line, &len, fp)) != -1)
    {
        memcpy(temp,line,strlen(line)-1);
        char *fkey=strtok(line,":");
        char *fvalue=strtok(NULL,":");
        
        if(strcmp(key,fkey)==0){
            lseek(fds[index],position,SEEK_SET);
            write(fds[index],blankspace,strlen(temp));
           
            break;
        }
        position=ftell(fp);
        
    }
    printf("length %d",length);
    sem_post(&mutex[index]);
    
}
int file_get(char *key, char *value)
{   
    /* Gets the value stored at offset */
    /* Does not depend on key argument */
    int found =0;
    
    int index=modulus(key,256,setSize);
    lseek(fds[index],0,SEEK_SET);
    sem_wait(&readerLocks[index]);
    readCounters[index]+=1;
    if(readCounters[index]==1)
        sem_wait(&mutex[index]);
    sem_post(&readerLocks[index]);
    char *line;
    size_t len=0;
    FILE *fp=fdopen(fds[index],"rb+");
    while ((getline(&line, &len, fp)) != -1)
    {
        char *fkey=strtok(line,":");
        char *fvalue=strtok(NULL,":");
        if(strcmp(key,fkey)==0){
            memcpy(value,fvalue,strlen(fvalue)-1);
            found=1;
            break;
        }
        
    }
    sem_wait(&readerLocks[index]);
    readCounters[index]-=1;
    if(readCounters[index]==0)
    {
        sem_post(&mutex[index]);
    }
    sem_post(&readerLocks[index]);
    return found;
}

off_t file_put(char *key,char *value)
 {
     /*
        if found then ask the offset where it is present and if the value noy matches with the present value ,update the given line
        if not present then search for empty line and insert there!
     */
    unsigned int index=modulus(key,256,setSize);
    lseek(fds[index],0,SEEK_SET);
    off_t position;
    //sem_wait(&mutex[index]);
    printf("[Write to File: %d]\n",index);
    char *line;
    char lin[514];
    size_t len=0;
    FILE *fp=fdopen(fds[index],"rb+");
    position=ftell(fp);
    while ((getline(&line, &len, fp)) != -1)
    {
        char *fkey=strtok(line,":"); 
        char *fvalue=strtok(NULL,":");
        if(strcmp(key,fkey)==0){
            if(strcmp(value,strtok(fvalue,"\n"))==0)
            {
                printf("(%s)(%s)\n",fkey,key);
               ///everything same then why insert?
               return 0;
            }
            else
            {
                printf("key:(%s)(%s)\n",fkey,key);
                printf("value:(%s)(%s)\n",fvalue,value);
                fflush(stdout);
                fseek(fp,position,SEEK_SET);
                snprintf(lin, strlen(key)+strlen(value)+2,"%s:%s\n",key,value);
                if(fputs(lin,fp)<0)
                    printf("\n[unable to perform file_put]\n");
                return 0;
            }
        }
        position=ftell(fp); 
    }     
    snprintf(lin, sizeof(lin),"%s:%s\n",key,value);
    if(write(fds[index], lin, strlen(lin))<0)
        printf("\n[unable to perform file_put]\n");
    

   // sem_post(&mutex[index]);

    return position;
}
int storage_init()
{
    /*
        define the array of file descriptors  depending on the prefix 
        define the array of readCount as well as the semaphore (read x and write y) for the same
        PUT,DEL would use write lock 
        GET would use read lock
        each write should return the line number
    */
    fds=(int *)malloc(sizeof(int)*setSize);
    readCounters=(int *)malloc(sizeof(int)*setSize);
    readerLocks=(sem_t *)malloc(sizeof(sem_t)*setSize);
    mutex=(sem_t *)malloc(sizeof(sem_t)*setSize);
    int i=0;
    char fileName[setSize+20];
    for(i=0;i<setSize;i++)
    {
        snprintf(fileName,sizeof(fileName),"File%d.txt",i);
        fds[i]=open(fileName, O_CREAT|O_RDWR,S_IRWXU);
        if(fds[i]<0)
        {
            printf("\n[Unable to Open File%d.txt]\n",i);
        }
        sem_init(&readerLocks[i],0,1);
        sem_init(&mutex[i],0,1);
        readCounters[i]=0;
    }

}
